   open Items
   open Overflow

   module I = OptionItem (PairItem (IntItem)(IntItem))
   include I
   type d = I.item

   let bot() = None
   let top() = Some (min_int, max_int)

   let min x y = if x < y then x else y
   let max x y = if x > y then x else y
   let widen_pos x y = if x >= y then Some x 
		else if x > 0 then try
			let x2 = 2*x
		     in if y >= x2 then Some y
			else Some x2
		     with _ -> None
		else Some (max y 0)
   let widen_neg x y = if x<=y then Some x
		else if x < 0 then try
			let x2 = 2*x
		     in if y <= x2 then Some y
			else Some x2
		     with _ -> None
		else Some (min y 0)

   let cup i1 i2 = match (i1,i2)
	with (None,_) -> i2
	|    (_,None) -> i1
	| (Some (a1,b1), Some (a2,b2)) -> Some (min a1 a2, max b1 b2)

   let cap i1 i2 = match (i1,i2)
	with (Some (a1,b1), Some (a2,b2)) -> let a = max a1 a2
					  in let b = min b1 b2
					  in if a > b then None
					     else Some (a,b)
	|  _ -> None

   let leq i1 i2 = match (i1,i2)
	with (None,_) -> true
	| (Some (a1,b1), Some (a2,b2)) -> a2<=a1 && b1<=b2
	| _ -> false

   let eq i1 i2 = match (i1,i2)
	with (None,None) -> true
	| (Some (a1,b1), Some (a2,b2)) -> a1=a2 && b1=b2
	| _ 		 -> false

   let widen i1 i2 = match (i1,i2)
	with (None,_) -> i2
	|    (_,None) -> i1
	| (Some (a1,b1), Some (a2,b2)) -> (match (widen_neg a1 a2, widen_pos b1 b2)
		with (None,_) -> top()
		|    (_,None) -> top()
		| (Some a, Some b) -> Some (a,b)
		)

   let narrow i1 i2 = cap i1 i2

   let add i1 i2 = match (i1,i2)
	with (Some (a1,b1), Some (a2,b2)) -> (try Some (a1+a2, b1+b2)
					      with _ -> top()
					     )
	| _ -> None

   let neg i = match i
	with Some (a,b) -> if a = min_int then 
				if b = min_int then i
				else top()
			   else Some (-b,-a)
	| None -> None

   let sub i1 i2 = add i1 (neg i2)

   let mul i1 i2 = match (i1,i2)
	with (Some (a1,b1), Some (a2,b2)) -> (try 
			   let x1 = a1*a2
			in let x2 = a1*b2
			in let x3 = b1*a2
			in let x4 = b1*b2
			in let a = min x1 (min x2 (min x3 x4))
			in let b = max x1 (max x2 (max x3 x4))
			in Some (a,b)
		  with _ -> top()
		  )
	| _ -> None

   let single x = Some (x,x)

