has_father (L1, L2) :- 	in (L2, _, L1).
has_father (L1, L2) :- 	out (L2, _, L1).
has_father (L1, L2) :- 	open (L2, _, L1).

has_in (X, N) 	:-    	in (L2, N, L1), 
			has_father (L1, X).
has_out (X, N) 	:-    	out (L2, N, L1), 
			has_father (L1, X).
has_open (X, N) :-    	open (L2, N, L1), 
			has_father (L1, X).
			
has_name    (L2,N) :-	name (_,N,L2).
has_father (L2,L1) :- 	name (L1,_,L2).

has_son (Y,N,L)    :- 	name (_,N,L),
			has_father (L,Y).
has_father (L,N,Y) :- 	name (_,N,L),
			has_father (L,Y),
			has_name (Y,N).

has_father (X,Y)   :- 	has_in (X,N),
			has_father (X,Z),
			has_son (Z,N,Y).

out_pair (X,Y)	:-	has_out (X,N), has_father (X,N,Y).
has_father (X,Z) :-	out_pair (X,Y), has_father (Y,Z).
open_pair (Y,X)	:-	has_open (X,N), has_son (X,N,Y).
has_father (X,Z) :-	has_father (X,Y), open_pair (Y,Z).



