query_pair_list (L1, L2) 	:- 	query_pair (X1, X2),
		  			trans (X1, A, L1),
					trans (X2, A, L2).
			
query (X)			:-	query_pair (X,top).
query (X)			:-	query_pair (top,X).
query_pair (X1,X2)	    	:-	query_pair_list (cons (X1,_), cons (X2,_)).

query_pair_list (L1, L2) 	:-	query_pair_list (cons (X1,L1), cons (X2,L2)),
					non_empty_pair (X1,X2).

non_empty_pair (X,top)		:-	non_empty (X).
non_empty_pair (top,X)		:-	non_empty (X).
non_empty_pair (X,X)		:-	non_empty (X).

non_empty_pair (X1,X2)  	:- 	query_pair (X1, X2), 
					trans (X1, A, L1), 
					trans (X2, A, L2),
					non_empty_pair_list (L1,L2).

non_empty_pair_list (nil,nil).

non_empty_pair_list (cons (X1,L1), cons (X2,L2)) 
		    		:- 	query_pair_list (cons (X1,L1), cons (X2,L2)),
					non_empty_pair (X1,X2),
					non_empty_pair_list (L1,L2).

