type ('a,'v) tree = Int of int | String of 'v | TVar of 'v | Cons of ('a * ('a,'v) tree list) | Atom of 'v | TUnknown

type 'v exp = EInt of int | EVar of 'v  
		| Add of ('v exp * 'v exp)
		| Sub of ('v exp * 'v exp)
		| Mul of ('v exp * 'v exp)
		| Div of ('v exp * 'v exp)
		| Mod of ('v exp * 'v exp)
		| Minus of 'v exp 

type comp = Lt | Gt | Le | Ge | E | Ne

type ('v,'b) arg    = Var of 'v | Unknown | Const of 'b
type ('a,'v,'b) query  =  Query of ('a * ('v,'b) arg list) 
		| Eq  of (('v,'b) arg * ('v,'b) arg)
		| Neq of (('v,'b) arg * ('v,'b) arg)
		| Is of ('v * 'v exp)
		| IsInt of 'v 
		| NegInt of 'v 
		| IsString of 'v 
		| NegString of 'v 
		| Comp of (comp * 'v exp * 'v exp)
		| Neg of ('a * ('v,'b) arg list)
		| Builtin of (('v -> 'b option) -> (('v * 'b) list) option)
		| True

type ('a,'v,'b) body   = ('a,'v,'b) query list
type ('a,'v,'b) clause = Clause of ('a * ('v,'b) arg list * ('a,'v,'b) body)

type inclause = (string, string, (string,string) tree) clause  
type inbody   = (string, string, (string,string) tree) body

type command =    Use of string
		| Reset
		| Observe of (string * int) 
		| Dir of string
		| Usedir of string
		| Outdir of string
		| Outfile of string
		| All
		| Dump
		| Solve
		| Topdown 
		| Help
		| Prog of inclause list 
		| Question of inbody 
		| Eof

(*
exception Single of command
*)

