open Items
open Table

module Forest (X:Item) = struct

   module Next = Table (X)
   type forest = Forest of forest Next.table 

   let new_forest () = Forest (Next.make_table 3)

   let rec from_tuple = function
           [] -> new_forest ()
       | x::xs ->  let t = Next.make_table 3
                in let _ = Next.add t x (from_tuple xs)
		in Forest t

   let rec insert (Forest t) = function
		[] -> ()
	     | x::xs -> (match Next.sub t x 
		with None -> Next.add t x (from_tuple xs)
		| Some t  -> insert t xs
		)

   
   let from_list tuples = let f = new_forest ()
		          in List.iter (insert f) tuples;
                             f

   let rec to_list (Forest f)  = let list = Next.to_list f
	     in let doit (x,f) = match to_list f
				 with [] -> [[x]] 
				   |   z -> List.map (fun xs -> x::xs) z
	     in let list = List.map doit list
	     in List.concat list

    let rec sub f list = let rec sub0 f = function
		[] -> Some f
	   | x::xs -> (match f with Forest f ->
		      (match Next.sub f x 
			with Some f -> sub0 f xs
			   | None   -> None))
	in match sub0 f list
		with Some f -> (match (to_list f, list)
				with 
			(*	([],[]) -> [] |		*)
				    ([],_)  -> [list]
				|    (z,_)   -> List.map (fun t -> list @ t) z)
		| None -> []

    let rec has_value f = function
	  [] -> true
	| x::xs -> match f with Forest f -> match Next.sub f x
			with None -> false
			| Some f -> has_value f xs
end
