open Items
open Table

module ForestMap (X:Item) = struct

   module Next = Table (X)
   type 'a forest_map = Map of 'a list ref * ('a forest_map Next.table)

   let make_forest_map0 () = Map (ref [], Next.make_table 3)
   let new_forest_map a = Map (ref [a], Next.make_table 3)

   let rec from_tuple tuple a = match tuple
      with  [] -> new_forest_map a
       | x::xs ->  let t = Next.make_table 3
                in let _ = Next.add t x (from_tuple xs a)
		in Map (ref [], t)

   let rec insert (Map (r, t)) tuple a = match tuple
	   with	[] -> r := a :: (!r)
	     | x::xs -> (match Next.sub t x 
		with None -> Next.add t x (from_tuple xs a)
		| Some t  -> insert t xs a
		)

   
   let from_list pairs = let f = make_forest_map0 ()
                      in let doit (tuple,a) = insert f tuple a
		          in List.iter doit pairs;
                             f

(*
   let rec to_list (Map (r,f))  = let list = Next.to_list f
	     in let doit (x,f) = List.map (fun (xs,a) -> (x::xs,a))
					  (to_list f)
	     in let list = List.map doit list
	     in let list0 = List.map (fun a -> ([],a)) (!r)
	     in List.concat (list0::list)

    let rec sub f = function
	  [] -> to_list f
	| x::xs -> (match f
		with Map (_,f) -> (match Next.sub f x
		with None -> []
		| Some f -> sub f xs
		)
          )
*)
     let rec consumers f = function
          [] -> (match f with Map (r,_) -> !r)
        | x::xs -> (match f with Map (r,f) ->
                ( match Next.sub f x
                	with None -> !r
                	| Some f -> !r @ consumers f xs)
                	)

     let rec image (Map (r,f)) = let list = Next.to_list f
	            in let list = List.map (fun (_,m) -> image m) list
		    in List.concat ((!r)::list)

     let rec all_consumers (Map (r,f)) = function
	  [] -> image (Map (r,f))
	| x::xs -> (match Next.sub f x
		with Some m -> (!r) @ all_consumers m xs
		| None -> !r
		)

end
