let init list = List.map (fun x->[x]) list

let rec merge = function
    ([],y) -> y
  | (x,[]) -> x
  | (x::xs,y::ys) -> if x <= y then x :: merge (xs, y::ys)
                     else y :: merge (x::xs, ys)

let rec merge_list = function
    []  -> []
  | [x] -> [x]
  | x1::x2::xs -> merge (x1,x2) :: merge_list xs

let rec iter = function
    [] -> []
  | [x] -> x
  |  x  -> iter (merge_list x)

let sort list = iter (init list) 

let rem_dup list = let list = sort list
		in let rec doit = function
			[] -> []
		   | [x]   -> [x]
		| x1::x2::xs -> if x1 = x2 then doit (x2 :: xs)
				else x1 :: doit (x2 :: xs)
		in doit list

let rec half = function
    [] -> ([],[])
  | [x] -> ([x],[])
  | x1::x2::xs -> let (xs1,xs2) = half xs
		  in (x1::xs1, x2::xs2)

let rec sort1 = function
    []  -> []
  | [x] -> [x]
  | list -> let (l1,l2) = half list
            in let l1 = sort l1
	    in let l2 = sort l2
            in merge (l1,l2) ;;
       
(*
let test n = let rec upto (x,a) = if x=n then a
			      else upto (x+1, x::a)
             in (sort (upto (0,[])));;
       
let test1 n = let rec upto (x,a) = if x=n then a
                              else upto (x+1, x::a)
             in (sort1 (upto (0,[])));;

test 100000;;
*)
