eval (X,X) :- int(X).
eval (X,X) :- string(X).

eval (pair(X1,X2), pair(Y1,Y2)) :- eval (X1,Y1),
			   	   eval (X2,Y2).
eval ([],[]).
eval (::(X,Xs), ::(Y,Ys)) :- eval (X,Y),
			     eval (Xs,Ys).

eval (app(F,X),Y) :- eval (X,Z),
		     app (F,Z,Y).

eq (X,X).
neq (X,Y) :- not (eq (X,Y)).

app (eq,pair(Y,Y),[Y]).
app (eq,pair(X,Y), []) :- neq (X,Y).

app (neq,pair(X,Y), [pair(X,Y)]) :- neq (X,Y).
app (neq,pair(X,X), []).

app (id,X,X).
app (const(X),_,X).
app (pi_1,pair(X,_),X).
app (pi_2,pair(_,X),X).

app (o(F,G),X,Y) :- app (G,X,Z),
		    app (F,Z,Y).

app (pair(F,G),X,pair(Y,Z)) :- app (F,X,Y),
			       app (G,X,Z).

app (single,X,[X]).

app (map(_),[],[]).
app (map(F),::(X,Xs),::(Y,Ys)) :- app (F,X,Y),
				  app (map(F),Xs,Ys).

app (cup,pair([],Y),Y).
app (cup,pair(::(X,Xs),Y),::(X,Zs)) :- app (cup,pair(Xs,Y),Zs). 

app (has,pair(X,[]),[]).
app (has,pair(X,::(X,Xs)),[X]).
app (has,pair(X,::(Y,Ys)),Z)   :- neq (X,Y),
				  app (has,pair(X,Ys),Z).
app (remdup,[],[]).
app (remdup,::(X,Xs),Z) :- app (has,pair(X,Xs),[X]),
			   app (remdup,Xs,Z).
app (remdup,::(X,Xs),::(X,Z)) :- app (has,pair(X,Xs),[]),
			         app (remdup,Xs,Z).

app (flatten,[],[]).
app (flatten,::(X,Xs),Z) :- app (flatten,Xs,Ys),
			    app (cup,pair(X,Ys),Z).

app (pairwith,pair([],_),[]).
app (pairwith,pair(::(X,Xs),Y),::(pair(X,Y),Zs)) :-
			app (pairwith,pair(Xs,Y),Zs).

app (cap,pair([],_),[]).
app (cap,pair(::(X,Xs),Y),::(X,Zs)) :- 
			app (has,pair(X,Y),[X]),
			app (cap,pair(Xs,Y),Zs).
app (cap,pair(::(X,Xs),Y),Zs) :- 
			app (has,pair(X,Y),[]),
			app (cap,pair(Xs,Y),Zs).
				
app (minus,pair([],_),[]).
app (minus,pair(::(X,Xs),Y),Zs) :- 
                        app (has,pair(X,Y),[X]),
                        app (minus,pair(Xs,Y),Zs).
app (minus,pair(::(X,Xs),Y),::(X,Zs)) :- 
                        app (has,pair(X,Y),[]),
                        app (minus,pair(Xs,Y), Zs).

app (swap,pair(X,Y),pair(Y,X)).

app (fmap(F),X,Y) :- app (o(flatten,map(F)),X,Y).
app (times,X,Y) :- app (o(o(o(map(swap),fmap(pairwith)),map(swap)),pairwith),X,Y).

/*
?- eval (app(map(o(single,swap)), [pair(1,"a"); pair(2,"b"); pair(3,"c")]), Y).
?- eval (app(id,[[1];[2]]), Y).
?- eval (app(cup,pair([1],[2;3])), Y).
?- eval (app(remdup,[1;2;2;1;3]),Y).
?- eval (app(flatten,[[1];[2]]), Y).
?- eval (app(map(id),[1]), Y).
?- eval (app(o(map(swap),pairwith), pair([1;2],"a")), Y).
?- eval (app(pairwith,pair([1;2], "a")), Y).
*/
?- eval (app(times,pair([1;2;3;4],["a";"b";"c";"d";"e"])), Y).



