
type state = int
type symbol = int
type automaton

type t = automaton

val is_final_state : t -> state -> bool
val is_deterministic : t -> bool
val number_of_states : t -> int
val states : t -> state list
val symbols : t -> symbol list
val iter : ((symbol * state list * state list) -> unit) -> t -> unit
val final_states : t -> state list
val leaf_states : t -> state list
val reduce : t -> t
val determinize : t -> (state -> 'a) -> (t * (state -> 'a list))
val minimize : t -> (state -> 'a) -> (t * (state -> 'a list))
val complement : t -> t
val emptiness : t -> bool
val do_transition : t -> symbol -> state list -> bool -> state list
val state : t -> ('a -> symbol) -> bool -> int -> 'a Tree_input.t -> state list
val member : 'a Tree_input.t -> t -> ('a -> symbol) -> bool -> bool
val from_list : (symbol * state list * state list) list -> state list 
                -> automaton
val to_string : t -> (symbol -> string) -> (state -> string) -> string 
val to_short_string : t -> string
