module type Dictionary =
   sig
      type ('a,'b) dictionary
      val create : unit -> ('a,'b) dictionary
      val add : ('a,'b) dictionary -> 'a * 'b -> unit
      val rm : ('a,'b) dictionary -> 'a -> unit
      val rm_rev : ('a,'b) dictionary -> 'b -> unit
      val replace : ('a,'b) dictionary -> 'a -> 'b -> unit
      val replace_rev : ('a,'b) dictionary -> 'b -> 'a -> unit
      val mem : ('a,'b) dictionary -> 'a -> bool
      val mem_rev : ('a,'b) dictionary -> 'b -> bool
      val lookup : ('a,'b) dictionary -> 'a -> 'b
      val lookup_rev : ('a,'b) dictionary -> 'b -> 'a
      val iter : ('a -> 'b -> unit) -> ('a,'b) dictionary -> unit
      val iter_rev : ('b -> 'a -> unit) -> ('a,'b) dictionary -> unit
      val fold : ('a -> 'b -> 'c -> 'c) -> ('a,'b) dictionary -> 'c -> 'c
      val to_list : ('a,'b) dictionary -> 'a list
      val to_list_rev : ('a,'b) dictionary -> 'b list
      val size : ('a,'b) dictionary -> int
   end

type ('a,'b) dictionary

val create : unit -> ('a,'b) dictionary
val add : ('a,'b) dictionary -> 'a * 'b -> unit
val rm : ('a,'b) dictionary -> 'a -> unit
val rm_rev : ('a,'b) dictionary -> 'b -> unit
val replace : ('a,'b) dictionary -> 'a -> 'b -> unit
val replace_rev : ('a,'b) dictionary -> 'b -> 'a -> unit
val mem : ('a,'b) dictionary -> 'a -> bool
val mem_rev : ('a,'b) dictionary -> 'b -> bool
val lookup : ('a,'b) dictionary -> 'a -> 'b
val lookup_rev : ('a,'b) dictionary -> 'b -> 'a
val iter : ('a -> 'b -> unit) -> ('a,'b) dictionary -> unit
val iter_rev : ('b -> 'a -> unit) -> ('a,'b) dictionary -> unit
val fold : ('a -> 'b -> 'c -> 'c) -> ('a,'b) dictionary -> 'c -> 'c
val to_list : ('a,'b) dictionary -> 'a list
val to_list_rev : ('a,'b) dictionary -> 'b list
val size : ('a,'b) dictionary -> int
