{ 

(* header *) 
open Parser
exception Eof

}

let letter = ['a'-'z' 'A'-'Z']
let number = ['0'-'9']
let name = letter ('_'|letter|number)* ("'")?

rule token = parse
    [' ' '\t']       { token lexbuf }    (* skip blanks *)
  | ['\n']           { EOL }
  | '('              { LPAREN }
  | ')'              { RPAREN }
  | '-''>'           { ARROW }
  | 'w''h''e''r''e'  { WHERE }
  | 'i''n'           { IN }
  | 'n''o''t'        { NOT }
  | ','              { COMMA }
  | '~'              { TILDE }
  | '.'              { ANY }
  | name as lxm      { ID (lxm) }
  | eof              { raise Eof }

{ 

(* trailer *) 

}
