
module type Simple_table =
   sig
      exception First_entry_exists
      type ('a,'b) table
      val create : unit -> ('a,'b) table
      val add : ('a,'b) table -> 'a * 'b -> unit
      val rm : ('a,'b) table -> 'a -> unit
      val replace : ('a,'b) table -> 'a -> 'b -> unit
      val mem : ('a,'b) table -> 'a -> bool
      val lookup : ('a,'b) table -> 'a -> 'b
      val iter : ('a -> 'b -> unit) -> ('a,'b) table -> unit
      val fold : ('a -> 'b -> 'c -> 'c) -> ('a,'b) table -> 'c -> 'c
      val to_list : ('a,'b) table -> 'a list
      val to_pair_list : ('a,'b) table -> ('a * 'b) list
      val size : ('a,'b) table -> int
   end

exception First_entry_exists

type ('a,'b) table 

val create : unit -> ('a,'b) table
val add : ('a,'b) table -> 'a * 'b -> unit
val rm : ('a,'b) table -> 'a -> unit
val replace : ('a,'b) table -> 'a -> 'b -> unit
val mem : ('a,'b) table -> 'a -> bool
val lookup : ('a,'b) table -> 'a -> 'b
val iter : ('a -> 'b -> unit) -> ('a,'b) table -> unit
val fold : ('a -> 'b -> 'c -> 'c) -> ('a,'b) table -> 'c -> 'c
val to_list : ('a,'b) table -> 'a list
val to_pair_list : ('a,'b) table -> ('a * 'b) list
val size : ('a,'b) table -> int
