
type symbol = Symbol.Symbol.t
type alphabet = Alphabet.Alphabet.t
type term = Term.Term.t
type state = State.State.t
type states = States.States.t
type rules = Rules.Rules.t
type automaton = (alphabet,states,rules) Automaton.automata_type
type tree = symbol Tree.t

exception Alphabets_not_equal

val debug : bool ref
val set_debug : bool -> unit
val empty : unit -> automaton
val membership : automaton -> term -> bool
val to_string : automaton -> string
val determinize : automaton -> automaton
val complement : automaton -> automaton
val union : automaton -> automaton -> automaton
val inter : automaton -> automaton -> automaton
val emptyness : automaton -> bool
val from_list : string list -> string list -> string list ->
                (string * string list * string list) list -> automaton

val alph_iter : (symbol -> unit) -> automaton -> unit

val sym_from_string : string -> symbol
val sym_to_string : symbol -> string
val sym_compare : symbol -> symbol -> int
val empty_tree : symbol

val state_from_string : string -> state
val state_to_string : state -> string
val state_compare : state -> state -> int

val states_from_list : string list -> states
val states_to_string : states -> string
val states_compare : states -> states -> int
val states_fold : (state -> 'a -> 'a) -> states -> 'a -> 'a
val final_states : automaton -> int list

val iter_rules : (symbol -> state list -> states -> unit) -> automaton -> unit
val next_states : automaton -> symbol -> state list -> states
val add_rule : automaton -> symbol -> state list -> states -> unit
val tree_to_term : tree -> term
val tree_to_term' : 'a Tree.t -> ('a -> symbol) -> term
val mem : automaton -> tree -> bool
val is_deterministic : automaton -> bool
