(** Some useful functions.

    This module implements additional functions. *)

val list_to_string : ('a -> string) -> string -> string -> string -> 
                     'a list -> string
   (** [list_to_string f open close sep l] represents the list [l]
       as string. Each element of [l] is converted by function [f]
       and the elements are separated by [sep]. The resulting string
       starts with the string [open] and ends with the string 
       [close]. *)
 
val get_jth_of_list : 'a list -> int list -> 'a list
   (** [get_jth_of_list l1 l2] returns all elements [l1 i] of list [l1]
       such that [i] is element of [l2]. *)

val tuple : 'a list list -> 'a list list
   (** [tuple lol] with [lol]=[l1],...[ln] returns the list of all 
       possible lists [k1],...,[km] such that each [ki] consists of 
       elements [e1],...,[en] ([n] is the length of [lol]) where [ej] 
       is element of [lj] for all [j]=1,...,n *)

val powerset : 'a list -> 'a list list
